#
#  AppController.rb
#  RubyRaiseMan
#

require 'osx/cocoa'
require 'PreferenceController.rb'

class AppController < OSX::NSObject 
  
  attr_reader :preference_controller
  
  ib_outlet :about_window
  
  def initialize
    default_values = OSX::NSMutableDictionary.dictionary
    # No need default_values.extend OSX::RCDictionaryAttachment since it is already mixed in
		# See oc_attachments.rb in RubyCocoa source
    color_as_data = OSX::NSKeyedArchiver.archivedDataWithRootObject(OSX::NSColor.yellowColor)
    default_values[PreferenceController::RRMTableBgColorKey] = color_as_data
    default_values[PreferenceController::RRMEmptyDocKey] = true
    OSX::NSUserDefaults.standardUserDefaults.registerDefaults(default_values)
  end
    
  def show_preference_panel(sender)
    unless @preference_controller
      @preference_controller = PreferenceController.alloc.init
    end
    @preference_controller.showWindow(self)
  end
  
  def show_about(sender)
    OSX::NSBundle.loadNibNamed_owner("About", self)
    @about_window.makeKeyAndOrderFront(self)
  end
  
  def applicationShouldOpenUntitledFile(sender)
    # OSX::NSLog("applicationShouldOpenUntitledFile")
    (OSX::NSUserDefaults.standardUserDefaults).boolForKey(PreferenceController::RRMEmptyDocKey)
  end
  
  # This method is automatically called when the window
  # This is because AppController is a delegate for the application
  def applicationDidResignActive(notification)
    # OSX::NSLog("applicationDidResignActive")
    OSX::NSBeep()
  end
end
