#
#  Person.rb
#  RubyRaiseMan
#


require 'osx/cocoa'

class Person < OSX::NSObject
  
  attr_accessor :person_name, :expected_raise
  
  def init
    super_init
    @person_name = "New Employee"
    @expected_raise = 5.0
    self
  end
  
  def setNilValueForKey(key)
    if key.isEqual?("expected_raise")
      expected_raise = 0.0
    else
      super_setNilValueForKey(key)
    end
  end
  
  # Saves the information to file
  def encodeWithCoder(coder)
    coder.encodeObject_forKey(person_name, "person_name")
    coder.encodeObject_forKey(expected_raise, "expected_raise")
  end
  
  # Reads the information from file
  def initWithCoder(coder)
    super_init
    self.person_name = coder.decodeObjectForKey("person_name")
    self.expected_raise = coder.decodeObjectForKey("expected_raise")
    self
  end

end
